# OpalFaxMediaStream Class Reference

`#include <t38proto.h>`

Inheritance diagram for OpalFaxMediaStream:

[legend]
Collaboration diagram for OpalFaxMediaStream:
[legend]

## Public Member Functions

| OpalFaxMediaStream (OpalConnection &conn, const OpalMediaFormat &mediaFormat, unsigned sessionID, bool isSource, OpalFaxSession &session)
virtual PBoolean | Open ()
virtual PBoolean | ReadPacket (RTP_DataFrame &packet)
virtual PBoolean | WritePacket (RTP_DataFrame &packet)
virtual PBoolean | IsSynchronous () const
virtual bool | InternalUpdateMediaFormat (const OpalMediaFormat &mediaFormat)

## Protected Member Functions

virtual void | InternalClose ()

## Protected Attributes

OpalFaxSession & | m_session

## Constructor & Destructor Documentation

OpalFaxMediaStream::OpalFaxMediaStream | ( | OpalConnection & | conn,
|  | const OpalMediaFormat & | mediaFormat,
|  | unsigned | sessionID,
|  | bool | isSource,
|  | OpalFaxSession & | session |
| ) |  |  |

## Member Function Documentation

virtual void OpalFaxMediaStream::InternalClose | ( |  | ) | `[protected, virtual]`

Close any internal components of the stream. This should be used in preference to overriding the Close() function as it is guaranteed to be called exactly once and avoids race conditions in the shut down sequence of a media stream.

Implements OpalMediaStream.

virtual bool OpalFaxMediaStream::InternalUpdateMediaFormat | ( | const OpalMediaFormat & | mediaFormat | ) | `[virtual]`

Reimplemented from OpalMediaStream.

virtual PBoolean OpalFaxMediaStream::IsSynchronous | ( |  | ) | const`[virtual]`

Indicate if the media stream is synchronous. If this returns true then the media stream will block of the amount of time it takes to annunciate the data. For example if the media stream is over a sound card, and 480 bytes of data are to be written it will take 30 milliseconds to complete.

Implements OpalMediaStream.

virtual PBoolean OpalFaxMediaStream::Open | ( |  | ) | `[virtual]`

Open the media stream using the media format.

The default behaviour simply sets the isOpen variable to true.

Reimplemented from OpalMediaStream.

virtual PBoolean OpalFaxMediaStream::ReadPacket | ( | RTP_DataFrame & | packet | ) | `[virtual]`

Read an RTP frame of data from the source media stream. The default behaviour simply calls ReadData() on the data portion of the RTP_DataFrame and sets the frames timestamp and marker from the internal member variables of the media stream class.

Reimplemented from OpalMediaStream.

virtual PBoolean OpalFaxMediaStream::WritePacket | ( | RTP_DataFrame & | packet | ) | `[virtual]`

Write an RTP frame of data to the sink media stream. The default behaviour simply calls WriteData() on the data portion of the RTP_DataFrame and and sets the internal timestamp and marker from the member variables of the media stream class.

Reimplemented from OpalMediaStream.

## Field Documentation

OpalFaxSession& OpalFaxMediaStream::m_session `[protected]`

The documentation for this class was generated from the following file:

- t38proto.h